=== debian/changelog ===
ros-melodic-message-relay (0.0.2-1stretch) stretch; urgency=high

  * Linter fixes.
  * Updated maintainers.
  * Contributors: Tony Baltovski

 -- Paul Bovbel <pbovbel@clearpath.ai>  Tue, 16 Jul 2019 04:00:00 -0000

ros-melodic-message-relay (0.0.1-1stretch) stretch; urgency=high

  * Initial commit
  * Contributors: Paul Bovbel, Tony Baltovski

 -- Paul Bovbel <pbovbel@clearpath.ai>  Tue, 24 Jan 2017 05:00:00 -0000
